package com.example.poop_fx_controller;

import com.example.model.GameModel;
import com.example.poop_fm_view.GameView;
import com.example.poop_fx_controller.Squash;
import javafx.fxml.FXML;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.StackPane;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Rectangle;

public class SceneController {

    @FXML
    public Rectangle paddle;

    @FXML
    public Circle ball;

    @FXML
    public StackPane box;

    private GameModel gameModel;

    private Squash squash;

    private GameView getView() {
        return new GameView(paddle, ball, box);
    }

    public void start() {
        box.requestFocus();
        gameModel = new GameModel(getView());
        squash = new Squash(gameModel);
        squash.start();
    }

    public void stop() {
        squash.stop();
    }


    public void onKeyTyped(KeyEvent keyEvent) {
        final double INCREMENT = 10.0;
        switch (keyEvent.getCode()) {
            case LEFT: gameModel.getPaddle().movePaddle(-INCREMENT);
                break;
            case RIGHT: gameModel.getPaddle().movePaddle(INCREMENT);
                break;
            case SPACE: gameModel.restartGame();
                break;
            default: break;
        }
    }
}